/* dmzSetup.js - API library for dmzSetup configuration */
/*
Copyright (c) 2005-2010 TeamF1, Inc.
All rights reserved.
*/
/*
modification history 
------------------------
vsr, 11MAR2011 added dmzIPCheck fun
vds, 29SEP2010
*/

function dmzSetupValidate ()
    {
    /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Invalid IP address.';
    var errMsgL10n2 = 'Invalid IP subnet mask.';
    var errMsgL10n3 = 'Invalid  starting IP address.';
    var errMsgL10n4 = 'Invalid  ending IP address.';
    var errMsgL10n5 = 'Invalid Primary DNS IP address.';
    var errMsgL10n6 = 'Invalid Secondary DNS IP address.';
    var errMsgL10n7 = 'Invalid WINS Server IP address.';
    var errMsgL10n8 = 'Invalid Relay Gateway IP address.';
    var errMsgL10n9 = 'for octet';
    var errMsgL10n10 = 'Please enter a valid DHCP lease time';
    var errMsgL10n11 = 'Please enter a valid LDAP Server.';
    var errMsgL10n12 = 'Please enter a valid Search Base.';
    var errMsgL10n13 = 'Invalid Lease Time:';
    var errMsgL10n14 = 'Hours';
    var errMsgL10n15 = 'Starting IP Address must be in DMZ subnet';
    var errMsgL10n16 = 'Ending IP Address must be in DMZ subnet';
    var errMsgL10n17 = 'DHCP IP Range Error: End address should be higher than or equal to Start address';
    var txtDomainErr = 'Please enter a valid Domain Name';
    var errMsgObjL10n = document.getElementById ('hd.invalIpAddrDmzsetUp');
    if (errMsgObjL10n) errMsgL10n1 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalIpSnmDmzsetUp');
    if (errMsgObjL10n) errMsgL10n2 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalStrtIpAddrDmzSetUp');
    if (errMsgObjL10n) errMsgL10n3 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalEndIpAddrDmzSetUp');
    if (errMsgObjL10n) errMsgL10n4 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalPrDnsIpAddrDmzSetUp');
    if (errMsgObjL10n) errMsgL10n5 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalSecDnsIpAddrDmzSetUp');
    if (errMsgObjL10n) errMsgL10n6 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalWinServIpAddrDmzSetUp');
    if (errMsgObjL10n) errMsgL10n7 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalRlyGtwIpAddrDmzSetUp');
    if (errMsgObjL10n) errMsgL10n8 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.foroctateDmzSetUp');
    if (errMsgObjL10n) errMsgL10n9 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.entrValDhcpLeaseTm');
    if (errMsgObjL10n) errMsgL10n10 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.entrValLdapServDmzSetup');
    if (errMsgObjL10n) errMsgL10n11 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.entrValSearchBaseDmzSetup');
    if (errMsgObjL10n) errMsgL10n12 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.entrValLeaseTm');
    if (errMsgObjL10n) errMsgL10n13 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.hrsDmzSetUp');
    if (errMsgObjL10n) errMsgL10n14 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.strtIpAddrInLnSnetVlp');
    if (errMsgObjL10n) errMsgL10n15 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.endIpAddrInLnSnetVlp');
    if (errMsgObjL10n) errMsgL10n16 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.dhcpIpRngeErrVlp');
    if (errMsgObjL10n) errMsgL10n17 = errMsgObjL10n.value;
     /* L10N Error Message Collection End */
    
	if(!document.getElementById('txtDhcpDomainName').disabled)
        {
        if (alphaNumericValueCheck ("txtDhcpDomainName", ".-", "Invalid domain name: ") == false)
		return false;
        }  

    if (ipv4AddrOctetsValidate ('tblLanSetupIpAddr', 'IPD', false, true,
             errMsgL10n1,errMsgL10n9+" ", true) == false)
        return false;
    if (ipv4AddrOctetsValidate ('tblLanSetupSnetMask', 'SM', false, true,
             errMsgL10n2, errMsgL10n9+" ", true) == false)
        return false;
    if(dmzIPCheck()==false)
        {
        return false; 
        }
    if (ipv4AddrOctetsValidate ('tblDhcpStartIp', 'IPD', false, true,
             errMsgL10n3, errMsgL10n9+" ", true) == false)
        return false;
    if (ipv4AddrOctetsValidate ('tblDhcpEndIp', 'IPD', false, true,
             errMsgL10n4, errMsgL10n9+" ", true) == false)
        return false;
    if (document.getElementById('rdbDhcpEnable').checked)
        {
        var lanIPInt = getIPInt('tblLanSetupIpAddr');
        var lanSnetInt = getIPInt('tblLanSetupSnetMask');
        var lanDhcpStIPInt = getIPInt('tblDhcpStartIp');
        var lanDhcpEndIPInt = getIPInt('tblDhcpEndIp');
        
        var lanIPStr = getIPStr('tblLanSetupIpAddr');
        var lanSnetStr = getIPStr('tblLanSetupSnetMask');
    
        if (!isInSubnet(lanDhcpStIPInt, lanIPInt, lanSnetInt))
            {
               alert (errMsgL10n15+":" + lanIPStr + "/" + lanSnetStr);
            return false;
            }
            
        if (!isInSubnet(lanDhcpEndIPInt, lanIPInt, lanSnetInt))
            {
               alert (errMsgL10n16+":" + lanIPStr + "/" + lanSnetStr);
            return false;
            }
    
        if (compareIP(lanDhcpStIPInt, lanDhcpEndIPInt) > 0)
            {
               alert (errMsgL10n17);
            return false;
            }
        }
    if (ipv4AddrOctetsValidate ('tblPriDnsServer', 'IPD', true, true,
             errMsgL10n5, errMsgL10n9+" ", true) == false)
        return false;
    if (ipv4AddrOctetsValidate ('tblSecDnsServer', 'IPD', true, true,
             errMsgL10n6, errMsgL10n9+" ", true) == false)
        return false;
    if (ipv4AddrOctetsValidate ('tblDhcpWinsSer', 'IPD', true, true,
             errMsgL10n7, errMsgL10n9+" ", true) == false)
        return false;
    if (ipv4AddrOctetsValidate ('tblDhcpRelayGw', 'IPD', false, true,
             errMsgL10n8, errMsgL10n9+" ", true) == false)
        return false;        
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtDhcpLeaseTime,"+" "+ errMsgL10n10;
    txtFieldIdArr[1] = "txtLdapSvr,"+errMsgL10n11;    
    txtFieldIdArr[2] = "txtLdapSearchBase,"+errMsgL10n12;
    txtFieldIdArr[3] = "txtDhcpDomainName,"+txtDomainErr;
    
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
    var leaseTimeObj = document.getElementById ('txtDhcpLeaseTime');
    if (!leaseTimeObj) return;
    if (!leaseTimeObj.disabled)
        if(numericValueRangeCheck (leaseTimeObj, '', '', 1, 262800, true, errMsgL10n13, errMsgL10n14) == false){
            return false;
        }
    return true;
    }
function dhcpDisable ()
    {
    depFieldCheck ('rdbDhcpDisable', true, 'txtDhcpDomainName txtDhcpLeaseTime', 'tblDhcpStartIp tblDhcpEndIp tblPriDnsServer tblSecDnsServer tblDhcpWinsSer tblDhcpRelayGw', '', '');
    fieldStateChangeWr ('chkLdapEnable txtLdapSvr txtLdapSearchBase txtLdapPort', '', '', '');        
    }
function dhcpEnable ()
    {
    depFieldCheck ('rdbDhcpEnable', true, '', 'tblDhcpRelayGw', 'txtDhcpDomainName txtDhcpLeaseTime chkLdapEnable', 'tblDhcpStartIp tblDhcpEndIp tblPriDnsServer tblSecDnsServer tblDhcpWinsSer');
    if (document.getElementById('rdbDhcpEnable').checked)
        {
        depFieldCheck ('chkLdapEnable', true, '', '', 'txtLdapSvr txtLdapSearchBase txtLdapPort', '');
        depFieldCheck ('chkLdapEnable', false, 'txtLdapSvr txtLdapSearchBase txtLdapPort', '', '', '');
        }
    }
function dhcpRelayCheck ()
    {
    depFieldCheck ('rdbDhcpRelays', true, 'txtDhcpDomainName txtDhcpLeaseTime', 'tblDhcpStartIp tblDhcpEndIp tblPriDnsServer tblSecDnsServer tblDhcpWinsSer', '', 'tblDhcpRelayGw');
    fieldStateChangeWr ('chkLdapEnable txtLdapSvr txtLdapSearchBase txtLdapPort', '', '', '');        
    }
function LDAPEnableCheck ()
    {
    depFieldCheck ('chkLdapEnable', true, '', '', 'txtLdapSvr txtLdapSearchBase txtLdapPort', '');
    depFieldCheck ('chkLdapEnable', false, 'txtLdapSvr txtLdapSearchBase txtLdapPort', '', '', '');    
    }    
function dmzSetupInit ()
    {
    checkPort();     
    }

function dmzPortCheck ()
    {
    var selValue= radioCheckedValueGet ('ConfigPort.LogicalIfName');
    var hddhcpEnble = document.getElementById('hddhcpEnble').value;
    if (!selValue) return;
    if(selValue == "LAN")
    	{
        fieldStateChangeWr ('chkEnableDProxy','tblDMZPortConf tblDhcpServerConf','','');
        }
    else
    	{
        fieldStateChangeWr ('','','chkEnableDProxy','tblDMZPortConf tblDhcpServerConf');
        dmzDhcpPortCheck ();
        }
    }


function checkPort()
    {
        var dmzPortObj = document.getElementById('hddmzPort');
        var dmzPortObjVal;
        if(dmzPortObj) dmzPortObjVal = dmzPortObj.value;                          
        if(dmzPortObjVal == "WAN2")
        {   
            fieldStateChangeWr('','divDmzSetUp','','')
        }
        else
        {   
            dmzPortCheck ();
        }        
    }
       
    
function dmzDhcpPortCheck ()
    {
    var dhcpSelValue = radioCheckedValueGet ('dhcp.dhcpEnabled');
    var hddhcpPortEnble = document.getElementById('hddhcpEnble').value;
    if (!dhcpSelValue) return;    
	switch (parseInt(dhcpSelValue, 10))
        {
        case 0:    /* Disable DHCP Server */
            fieldStateChangeWr ('chkLdapEnable txtLdapSvr txtDhcpDomainName txtLdapSearchBase txtLdapPort txtDhcpLeaseTime', 'tblDhcpStartIp tblDhcpEndIp tblPriDnsServer tblSecDnsServer tblDhcpWinsSer tblDhcpRelayGw', '', ''); 
            break;
        case 1:    /* Enable DHCP Server */
            fieldStateChangeWr ('', 'tblDhcpRelayGw', 'chkLdapEnable txtDhcpDomainName txtDhcpLeaseTime', 'tblDhcpStartIp tblDhcpEndIp tblPriDnsServer tblSecDnsServer tblDhcpWinsSer');
            LDAPEnableCheck ();
            break;
            
        case 3:    /* DHCP Relay */
            fieldStateChangeWr ('chkLdapEnable txtLdapSvr txtDhcpDomainName txtLdapSearchBase txtLdapPort txtDhcpLeaseTime', 'tblDhcpStartIp tblDhcpEndIp tblPriDnsServer tblSecDnsServer tblDhcpWinsSer', '', 'tblDhcpRelayGw'); 
            break;    
        }
    } 
    
/******************************************************************** 
* dmzIPCheck- Validates DMZ Ip Address
* 
* This routine validates vlan ip address and checks whether it is in subnet of 
* WAN or any other Vlan
* 
* RETURNS: TRUE or FALSE 
*/
function dmzIPCheck()
    {
    var count = parseInt(document.getElementById('hdCount').value,10);
    var resIp = getIPInt('tblLanSetupIpAddr');
    var dmzIP = document.getElementById('tblLanSetupIpAddr');
    var resSnetMask = getIPInt('tblLanSetupSnetMask');
    for (var i = 1; i < count; i++)
       {
       var ifname = document.getElementById('hdIfName'+ i).value;
       var IpAddrId = "hdIpAddr" + i;
       var SnetMaskId = "hdSnet"+ i;
       var Ip = getIPInt1(IpAddrId);
       var IpMask = getIPInt1(SnetMaskId);
       var IpStr = document.getElementById(IpAddrId).value;
       var IpMaskStr = document.getElementById(SnetMaskId).value;
       var SubnetStr = IpStr + "/" + IpMaskStr;
           if (isInSubnetWithBroadCastIp(Ip, resIp, resSnetMask))
               {
               var errorstr = "DMZ IP Address must not be in the subnet of " + ifname +":" + SubnetStr;
               alert (errorstr);
               return false;
               }
       }
       /*Begin:Subnet Checking for lo interface*/
       var ipAddr_Lo = getIPInt1('loIpAddr');
       var subnet_Lo = getIPInt1('loSnet');
       if (isInSubnetWithBroadCastIp(resIp , ipAddr_Lo, subnet_Lo))
          {
          var errorstr = "Local interface IP address is in the same subnet. Please specify IP address in a different subnet.";
          alert (errorstr);
          dmzIP.focus();
          return false;
          }
          /*End:Subnet Checking for lo interface*/
          /* Subnet checking for dhcp over ipsec */
          /*
          var dhcpOverIpSecAddr = getIPInt1('hdDhcpOverIpSec');
          var dhcpOverIpSecSnet = getIPInt1('hdDhcpOverIpSecSnet');
          if (isInSubnetWithBroadCastIp(resIp , dhcpOverIpSecAddr, dhcpOverIpSecSnet))
             {
             var errorstr = "DHCP Range Over IpSec is in the same subnet. Please specify IP address in a different subnet.";
             alert (errorstr);
             dmzIP.focus();
             return false;
             }
             */
             /* End of Subnet Checking for dhcp over ipsec */
             
             /*Begin: Subnet checking for WAN1 */
             var wan1IpAddrObj = document.getElementById('wan1IpAddr');
             var wan1SecSnetObj = document.getElementById('wan1IpSnet');
             var wanSnetStr = wan1IpAddrObj.value + "/" + wan1SecSnetObj.value;
             if (wan1IpAddrObj && wan1IpAddrObj.value != "" && wan1IpAddrObj.value != "0.0.0.0" && wan1SecSnetObj && wan1SecSnetObj.value != "" && wan1SecSnetObj.value != "0.0.0.0")
                {
                 var wanIPAddr = getIPInt1('wan1IpAddr');
                 var wanSnetMask = getIPInt1('wan1IpSnet');
                 if (isInSubnetWithBroadCastIp(resIp, wanIPAddr, wanSnetMask) || isInSubnetWithBroadCastIp(wanIPAddr, resIp, resSnetMask))
                    {
                    var errorstr = "LAN (Local Network) IP Address must not be in the subnet of WAN (Internet):" + wanSnetStr;
                    alert (errorstr);
                    dmzIP.focus();
                    return false;
                    }
                }
                /*End: Subnet checking for WAN1 */
                
                fixIpAdd = document.getElementById('fixIp').value
                if( fixIpAdd == ""){}
                else
                   {
                   var fixIpAddInt=getIPInt1('fixIp');
                   if (isInSubnetWithBroadCastIp(fixIpAddInt, resIp, resSnetMask)) {}
                   else
                      {
                      var errorstr = "Remove all DHCP Reserved DMZ IPs first";
                      alert(errorstr);
                      return false
                      }
                   }
                   var dmzIpAddr = getIPStr('tblLanSetupIpAddr');
                   var startIpAddr = getIPStr('tblDhcpStartIp');
                   var endIpAddr = getIPStr('tblDhcpEndIp');
                   var dmzIpAddrArr = dmzIpAddr.split (".");
                   if(startIpAddr != false && endIpAddr != false)
                      {
                      var startIpAddrArr = startIpAddr.split (".");
                      var endIpAddrArr = endIpAddr.split (".");
                      var end = 0;
                      var start = 0;
                      for (var i = 0; i <= 3; i++)
                         {
                         if(dmzIpAddrArr[i] == startIpAddrArr[i])
                             start++;
                         if(dmzIpAddrArr[i] == endIpAddrArr[i])
                             end++;
                         }
                         if((start == 4) &&(end == 4))
                            {
                                 var errorstr = "DHCP starting and ending IPs should not be equal to DMZ IP";
                                 alert (errorstr);
                                 return false;
                            }
                         }
                         return true;
   }
