/* rip.js - API library for RIP configuration */

/* Copyright 2010 - 2013 TeamF1, Inc. */

/*
modification history 
------------------------
01b,3MAY11,mvb  modified, added isproblem char check for MD5 Auth field.
01a,5OCT10,mvb  written. 
*/


function ripAuthTypeCheck ()
	{
	var selValue = radioCheckedValueGet ('Rip.AuthenticationType');
	if (!selValue) return;
	switch (parseInt(selValue, 10))
		{
		case 1:	/* YES */
			fieldStateChangeWr ('','','','tblRipKeyInfo');
			break;
		default: /* NO */
			fieldStateChangeWr ('','tblRipKeyInfo','','');
			break;
		}
	}

function ripVersionCheck ()
    {
    var selValue = comboSelectedValueGet ('selKeyVersion');
    if (!selValue) return;
    switch (parseInt(selValue, 10))
        {
        case 0: /*None*/
        case 1: /* RIP 1*/
            fieldStateChangeWr ('','tblRipKeyInfo tblRipAuthInfo','','');
            radioObjWithValueSelect ('Rip.AuthenticationType', 0);
            break;
        default:
            fieldStateChangeWr ('','','','tblRipKeyInfo tblRipAuthInfo');
            ripAuthTypeCheck ();
            break;
        }
    
    }

function numObj (id, minLen, minVal, maxVal, errMsg)
	{
	this.id = id;
	this.minLen = minLen;
	this.minVal = minVal;
	this.maxVal = maxVal;
	this.errMsg = errMsg;
	}
function dateValidate (monthId, dayId, yearId, hoursId, minId, secId)
	{
	
	 /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Invalid Month: Please enter a value between 1 - 12';    
    var errMsgL10n2 = 'Invalid Day: Please enter a value between 1 - 31';    
    var errMsgL10n3 = 'Invalid Year: Please enter a valid year';    
    var errMsgL10n4 = 'Invalid Hours: Please enter a value between 0 - 23';    
    var errMsgL10n5 = 'Invalid Minutes: Please enter a value between 0 - 59';    
    var errMsgL10n6 = 'Invalid Seconds: Please enter a value between 0 - 59'
    var errMsgObjL10n = document.getElementById ('hd.invalMonth');
    if (errMsgObjL10n) errMsgL10n1 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalDay');
    if (errMsgObjL10n) errMsgL10n2 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalYear');
    if (errMsgObjL10n) errMsgL10n3 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalHour');
    if (errMsgObjL10n) errMsgL10n4 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalMin');
    if (errMsgObjL10n) errMsgL10n5= errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalSec');
    if (errMsgObjL10n) errMsgL10n6= errMsgObjL10n.value;
     /* L10N Error Message Collection End */
	
	var dtVarObj = new Array ();
	dtVarObj[0] = new numObj(monthId, 1, 1, 12, errMsgL10n1);
	dtVarObj[1] = new numObj(dayId, 1, 1, 31, errMsgL10n2);
	dtVarObj[2] = new numObj(yearId, 1, 0, 0, errMsgL10n3);
	dtVarObj[3] = new numObj(hoursId, 1, 0, 23, errMsgL10n4);
	dtVarObj[4] = new numObj(minId, 1, 0, 59, errMsgL10n5);
	dtVarObj[5] = new numObj(secId, 1, 0, 59, errMsgL10n6);
	var idObj = null;
	for (var idx = 0; idx < dtVarObj.length; ++idx)
		{
		idObj = document.getElementById (dtVarObj[idx].id);
		if (!idObj || idObj.disabled) continue;
		if ((idObj.value.length < dtVarObj[idx].minLen) ||
			(parseInt (idObj.value, 10) < dtVarObj[idx].minVal) ||
			((dtVarObj[idx].maxVal != 0) && (parseInt (idObj.value, 10) > dtVarObj[idx].maxVal)))
			{
			alert (dtVarObj[idx].errMsg);
			idObj.focus ();
			return false;
			}
		}
	return true;
	}
function ripValidate ()
	{
	 /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Invalid First MD5 Key ID: Please enter value between 1 - 255.';    
    var errMsgL10n2 = 'Invalid First MD5 Key ID:';    
    var errMsgL10n3 = 'Please enter first MD5 authentication key';       
    var errMsgL10n4 = 'Invalid Second MD5 Key ID: Please enter value between 1 - 255.';    
    var errMsgL10n5 = 'Invalid Second MD5 Key ID:';      
    var errMsgL10n6 = 'Please enter second MD5 authentication key';
     var errMsgObjL10n = document.getElementById ('hd.invalFrstMd5KyIdBet');
    if (errMsgObjL10n) errMsgL10n1 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalFrstMd5KyId');
    if (errMsgObjL10n) errMsgL10n2 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.entrFstMd5AuthKey');
    if (errMsgObjL10n) errMsgL10n3 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalSecMd5KyIdBet');
    if (errMsgObjL10n) errMsgL10n4 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalSecMd5KyId');
    if (errMsgObjL10n) errMsgL10n5= errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.entrSecMd5AuthKey');
    if (errMsgObjL10n) errMsgL10n6= errMsgObjL10n.value;
     /* L10N Error Message Collection End */

	var dtObj = new Array('txtMonth1', 'txtMonth2', 'txtMonth3', 'txtMonth4', 
     			           'txtDate1', 'txtDate2', 'txtDate3', 'txtDate4', 
     			           'txtHr1', 'txtHr2', 'txtHr3', 'txtHr4', 
     			           'txtMin1', 'txtMin2', 'txtMin3', 'txtMin4', 
     			           'txtSec1', 'txtSec2', 'txtSec3', 'txtSec4'
     			);
     var dayObj = new Array('txtDate1', 'txtDate2', 'txtDate3', 'txtDate4');
     var monObj = new Array('txtMonth1', 'txtMonth2', 'txtMonth3', 'txtMonth4');
     var yrObj = new Array('txtYear1','txtYear2','txtYear3','txtYear4');
	 
    var md5KeyIdObj = document.getElementById('txtMd5KeyId1');
    if (md5KeyIdObj && !md5KeyIdObj.disabled)
        {
        if (numericValueRangeCheck (md5KeyIdObj, 1, 
                                 errMsgL10n1,
                                1, 255, true,  errMsgL10n2+":", "") == false)
        return false;
        }
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtMd5AuthKey1," +
                        errMsgL10n3;
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
    if (isProblemCharArrayCheck(txtFieldIdArr) == false)
        return false;
                       
    if (dateValidate ('txtMonth1', 'txtDate1', 'txtYear1', 'txtHr1', 'txtMin1', 'txtSec1') == false)
    	return false;
    if (dateValidate ('txtMonth2', 'txtDate2', 'txtYear2', 'txtHr2', 'txtMin2', 'txtSec2') == false)
    	return false;
    
    if(dateCompare("tblBeforeDate1","tblAfterDate1")==false)
        {
        alert("Before Date should be lesser than After date.");
        return false;
        }
    
    md5KeyIdObj = document.getElementById('txtMd5KeyId2');
    if (md5KeyIdObj && !md5KeyIdObj.disabled)
        {
        if (numericValueRangeCheck (md5KeyIdObj, 1, 
                                 errMsgL10n4,
                                1, 255, true,  errMsgL10n5+":", "") == false)
        return false;
        }
    var txtFieldIdArry = new Array ();    
    txtFieldIdArry[0] = "txtMd5AuthKey2," +
                        errMsgL10n6;
    if (txtFieldArrayCheck (txtFieldIdArry) == false)
         return false;
    if (isProblemCharArrayCheck(txtFieldIdArry) == false)
        return false;
                       
    if (dateValidate ('txtMonth3', 'txtDate3', 'txtYear3', 'txtHr3', 'txtMin3', 'txtSec3') == false)
    	return false;
    if (dateValidate ('txtMonth4', 'txtDate4', 'txtYear4', 'txtHr4', 'txtMin4', 'txtSec4') == false)
    	return false;
	
	if(dateCompare("tblBeforeDate2","tblAfterDate2")==false)
        {
        alert("Before Date should be lesser than After date.");
        return false;
        }
	
	for (var idz = 0; idz < yrObj.length; ++idz)
		{
		var Err = idz + 1;
		var errString = "date" + Err + "Err";
		if(yearCheck(document.getElementById(yrObj[idz]), dayObj[idz], errString) == false)
        	return false;
		}
	
	for (var idy = 0; idy < dtObj.length; ++idy)
		{
		var Err = idy + 1;
		var tmp = idy + 1;
		if(tmp > 4)
			{
			Err = tmp % 4;
			if(Err < 1){Err = 4}
			} 
		var errStr = "date" + Err + "Err";
		if(dateCheck(document.getElementById(dtObj[idy]),errStr) == false)
        	return false;       
		}
	
	for (var idm = 0; idm < dayObj.length; ++idm)
	{
	    var err = idm + 1;
	    var errString = "date" + err + "Err";
	    if( dayCheck(document.getElementById(dayObj[idm]), monObj[idm], errString, yrObj[idm]) == false )
	        return false;
	}
    return true;
	}
	
function dateCheck(val, errObjId)
	{
	 /* L10N Error Message Collection Start */
    var errMsgL10n1 = "Please enter it in 2 digit Format:";
    var errMsgObjL10n = document.getElementById ('hd.2digFrmt');
    if (errMsgObjL10n) errMsgL10n1 = errMsgObjL10n.value;
    /* L10N Error Message Collection End */

	if((val == null) || val.disabled)
		return true;
	var str = val.value;
	if (str.length < 2)
		{
		alert (errMsgL10n1+" 0" + str);
		val.focus();
		return false;
		}
	return true;
	}
	
// Months and Day Format Validation
function dayCheck(val, mnthId, errObjId, yearObjId)
{   
     /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Day should be in the range of (1 - 29) for the Month 2(February) in a Leap Year';
    var errMsgL10n2 = 'Day should be in the range of (1 - 28) for the Month 2(February)';   
    var errMsgL10n3 = 'Day should be in the range of (1 - 30) for the months April, June, September, November';
    var errMsgObjL10n = document.getElementById ('hd.frMonth2Leap');
    if (errMsgObjL10n) errMsgL10n1 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.frMonth2');
    if (errMsgObjL10n) errMsgL10n2 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.frMonths');
    if (errMsgObjL10n) errMsgL10n3 = errMsgObjL10n.value;
    /* L10N Error Message Collection End */

	if((val == null) || val.disabled)
		return true;
    var day = parseInt (val.value, 10);
    var month = parseInt (document.getElementById(mnthId).value, 10);
    if (month == 2) 
    {
    	if (document.getElementById(yearObjId).value != "" && !isNaN(document.getElementById(yearObjId).value))
    		{
			if (isLeapYear (parseInt (document.getElementById(yearObjId).value, 10)) && day > 29)
				{
			    alert (errMsgL10n1);
			    val.focus();
			    return false;
				}
			else if (!isLeapYear (parseInt (document.getElementById(yearObjId).value, 10)) && day > 28) {
			    alert (errMsgL10n2);
			    val.focus();
			    return false;		
				}
			}
		else if (day > 28) {
		    alert (errMsgL10n2);
		    val.focus();
		    return false;		
			}	
	}
	if ((month==4)||(month==6)||(month==9)||(month==11)) {
		if (day > 30) 
		{ 
		    alert (errMsgL10n3);
		    val.focus();
		    return false; 
		}
	}
    return true;
}

// leap year and Format Validation
function yearCheck(val, dateId ,errObjId)
{
	 /* L10N Error Message Collection Start */
    var errMsgL10n1 = "Please enter in 4 digits Format: '2010'";
    var errMsgObjL10n = document.getElementById ('hd.4digFrmt');
    if (errMsgObjL10n) errMsgL10n1 = errMsgObjL10n.value;
    /* L10N Error Message Collection End */

	if((val == null) || val.disabled)
		return true;
	var year = val.value;
	if (year.length < 4)
	{
		alert (errMsgL10n1);
		val.focus();
		return false;
	}
	return true;
}

// leap year and Format Validation
function isLeapYear (year)
	{
    if ( ( (year%4==0)&&(year%100 != 0) ) || (year%400==0) ) 
	   return true;
	return false;
	}
	
/********************************************************************
* dateCompare : compare the date and validate 
*
* This functions compare before Date and After Date and validates the value
* of the Date and returns true
* if the configuration is valid else returns false
*
* RETURNS: TRUE or FALSE
*
*/

function dateCompare(beforeDate,afterDate)
    {
    var txtNdate = new Date();
    var txtN2date = new Date();
    var txtBdateObj = document.getElementById(beforeDate);
    var txtAdateObj = document.getElementById(afterDate);
    var txtBdateTag = txtBdateObj.getElementsByTagName("INPUT");
    if(!txtBdateTag.length)
        {
        return 0;
        }
    var txtAdateTag = txtAdateObj.getElementsByTagName("INPUT");
    if(!txtAdateTag.length)
        {
        return 0;
        }
    if(!txtBdateTag[1].disabled)
        {
        txtNdate.setFullYear(parseInt(txtBdateTag[2].value,10),parseInt(txtBdateTag[0].value,10)-1,parseInt(txtBdateTag[1].value,10));
        txtNdate.setHours(parseInt(txtBdateTag[3].value,10),parseInt(txtBdateTag[4].value,10),parseInt(txtBdateTag[5].value,10));
        txtN2date.setFullYear(parseInt(txtAdateTag[2].value,10),parseInt(txtAdateTag[0].value,10)-1,parseInt(txtAdateTag[1].value,10));
        txtN2date.setHours(parseInt(txtAdateTag[3].value,10),parseInt(txtAdateTag[4].value,10),parseInt(txtAdateTag[5].value,10));
        return (txtNdate<txtN2date);
        }
        return true;
    };    
