/* sslvpnClient_IPv6.js - API library for sslvpnClient configuration */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01a,11OCT12,mvb  written. 
*/

function clientIPValidate ()
    {
        
    if(document.getElementById ('txtDnsSuffix').value != "")
        {
        if(validateFQDN('txtDnsSuffix') == false) 
           return false; 	
        }

	if(document.getElementById('tblPriDnsServer').value != '' || document.getElementById('tblSecDnsServer').value != '')
	    {
	    if(ipVersionCheck ('tblPriDnsServer', 'tblSecDnsServer') == false)
		    return false;
		}

	var beginClientAddrObj = document.getElementById('beginClientAddr');
	if(!(beginClientAddrObj.disabled) && beginClientAddrObj.value != '')
	    {
	    if (ipv6Validate ('beginClientAddr', false, true, '') == false)
	        return false;
	    }
	var endClientAddrObj = document.getElementById('endClientAddr');
	if(!(endClientAddrObj.disabled) && endClientAddrObj.value != '')
	    {
	    if (ipv6Validate ('endClientAddr', false, true, '') == false)
	        return false;
	    }
	if(beginClientAddrObj.value != '' && endClientAddrObj.value != '')
	    {
	    if (startEndCompare('beginClientAddr','endClientAddr') == false)
		    return false;
	    }
		
	return true;	
    }

function fullTunnelCheck_IPv6 ()
	{
	var obj = document.getElementById('chkEnbFullTnl');
	if(obj.checked)
	    fieldStateChangeWr ('','tblIPv6ClientRoutes tblAddRoute','','');
	else
	   fieldStateChangeWr ('','','','tblIPv6ClientRoutes tblAddRoute');	
	}

function getFlagVal()
    {
    var hdIPModeObj = document.getElementById('isDisable');
    var hdIPModeVal = '';
    var flag = 0;
    if(hdIPModeObj) hdIPModeVal = hdIPModeObj.value;
    if(hdIPModeVal != '' && hdIPModeVal == 3)
        {
        flag = 1; //IPv6Addr
        }
    else
        {
        flag = 2; /*ipv4 validation */
        }        
    return flag;    
    }

function VPNTunnelclientIPv6Validate ()
	{
	var txtFieldIdArr = new Array ();
	txtFieldIdArr[0] = "tblSnmpIpAddr,Please enter valid IPv6 address";
	txtFieldIdArr[1] = "tblWi1IpSnetmask,Please enter valid Prefix Length";
	if (txtFieldArrayCheck (txtFieldIdArr) == false)
	    return false;
	
	if (ipv6Validate ('tblSnmpIpAddr', true, true, '') == false)
	    return false;
	
	if (numericValueRangeCheck (document.getElementById ('tblWi1IpSnetmask'), '', '', 1, 128, true, '', '') == false)
	    return false;

    var maxLimitObj = document.getElementById ('hdMaxLimitVal');
    var maxLimitVal = parseInt (maxLimitObj.value, 10);
    if(maxCountCheck ('hdCount', maxLimitVal, 'tblErrMsg') == false)
        return false;        
        
    return true;
	}  


function ipVersionCheck (ipAddr, ipAddr2)
    {
    var flagg = getFlagVal();
    if(flagg == 1)
        {
        var tblIpAddrObj = document.getElementById (ipAddr);
        var whichIpAddr = isIpv4OrIpv6 (tblIpAddrObj);
        if(whichIpAddr == "IPV4")
            {
            if (ipv4Validate (ipAddr, 'IP', false, true, "Invalid IP Address.", "for octet ", true) == false)
                return false;
            if(document.getElementById('tblSecDnsServer').value != '')
                {
                if (ipv4Validate (ipAddr2, 'IP', false, true, "Invalid IP Address.", "for octet ", true) == false)
                    return false;
                }
            }
        else if(whichIpAddr == "IPV6")
            {
            if (ipv6Validate (ipAddr, true, true, '') == false)
                return false;
            if(document.getElementById('tblSecDnsServer').value != '')
                {
                if (ipv6Validate (ipAddr2, true, true, '') == false)
                    return false;
                }
            }
        else
            {
            alert('Please enter valid IPv4 or IPv6 address');
            tblIpAddrObj.focus();
            return false;
            }
        }
    else
        {
        if (ipv4Validate (ipAddr, 'IP', false, true, "Invalid IP Address.", "for octet ", true) == false)
            return false;
        if(document.getElementById('tblSecDnsServer').value != '')
            {
            if (ipv4Validate (ipAddr2, 'IP', false, true, "Invalid IP Address.", "for octet ", true) == false)
                return false;
            }
        }
    return true;
    }
    
function sslvpnIPv6Init ()
    {
    showWarning ();
    fullTunnelCheck_IPv6 ();
    enableCheck();
    }
