/* wanSetup.js - API library for wan setting configuration */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01b,16MAR11,vsr  added wanIPCheck
01a,30SEP10,mvb  written. 
*/



/******************************************************************** 
* wanSetupValidate - validates the page
* 
* This function validates all the values in the page
* 
* RETURNS: TRUE or FALSE 
*/

function wanSetupValidate ()
    {
    /* L10N Error Message Collection Start */
    var loginIdErrMsg = "Invalid ISP login information: Please enter a valid login name or ID provided by your ISP";
    var errMsgObjL10N = document.getElementById('hdLoginIdErr');
    if (errMsgObjL10N) loginIdErrMsg = errMsgObjL10N.value;
    var resetHoursErrMsg = "Please enter a valid Hours value";
    errMsgObjL10N = document.getElementById('hdResetHoursErr');
    if (errMsgObjL10N) resetHoursErrMsg = errMsgObjL10N.value;
    var resetMinsErrMsg = "Please enter a valid Minutes value";
    errMsgObjL10N = document.getElementById('hdResetMinsErr');
    if (errMsgObjL10N) resetMinsErrMsg = errMsgObjL10N.value;
    var resetDelayErrMsg = "Please enter a valid Delay in Seconds";
    errMsgObjL10N = document.getElementById('hdResetDelayErr');
    if (errMsgObjL10N) resetDelayErrMsg = errMsgObjL10N.value;
    var resetHoursErrMsg1 = "Invalid Hours value:";
    errMsgObjL10N = document.getElementById('hdResetHoursErr1');
    if (errMsgObjL10N) resetHoursErrMsg1 = errMsgObjL10N.value;
    var resetMinsErrMsg1 = "Invalid Minutes value";
    errMsgObjL10N = document.getElementById('hdResetMinsErr1');
    if (errMsgObjL10N) resetMinsErrMsg1 = errMsgObjL10N.value;
    var resetDelayErrMsg1 = "Invalid Delay value:";
    errMsgObjL10N = document.getElementById('hdResetDelayErr1');
    if (errMsgObjL10N) resetDelayErrMsg1 = errMsgObjL10N.value;
    var resetDelayUnits = "Seconds";
    errMsgObjL10N = document.getElementById('hdResetDelayUnits');
    if (errMsgObjL10N) resetDelayUnits = errMsgObjL10N.value;
    var idleTimeoutErrMsg = "Invalid idle timeout value: Please enter a value between 5 and 999 minutes"
    errMsgObjL10N = document.getElementById('hdIdleTimeoutErr');
    if (errMsgObjL10N) idleTimeoutErrMsg = errMsgObjL10N.value;
    var invalidIdleTOErr = "Invalid idle timeout value:";
    errMsgObjL10N = document.getElementById('hdInvalidIdleTimeoutErr');
    if (errMsgObjL10N) invalidIdleTOErr = errMsgObjL10N.value + ": ";
    var minutes = "minutes.";
    errMsgObjL10N = document.getElementById('hdMinutes');
    if (errMsgObjL10N) minutes = errMsgObjL10N.value;
    var myIpAddreErr = "Invalid IP address in My IP Address field."
    errMsgObjL10N = document.getElementById('hdMyIpAddrErr');
    if (errMsgObjL10N) myIpAddreErr = errMsgObjL10N.value;
    var forOctet = "for octet "
    errMsgObjL10N = document.getElementById('hdForOctet');
    if (errMsgObjL10N) forOctet = errMsgObjL10N.value + " ";
    var svrIpAddreErr = "Invalid IP address in Server IP Address field.";
    errMsgObjL10N = document.getElementById('hdSvrIpAddrErr');
    if (errMsgObjL10N) svrIpAddreErr = errMsgObjL10N.value;
    var staticIpAddrErr = "Invalid static IP address.";
    errMsgObjL10N = document.getElementById('hdStaticIpAddrErr');
    if (errMsgObjL10N) staticIpAddrErr = errMsgObjL10N.value;
    var staticIpAddrErr = "Invalid static IP address.";
    errMsgObjL10N = document.getElementById('hdStaticIpAddrErr');
    if (errMsgObjL10N) staticIpAddrErr = errMsgObjL10N.value;
    var snetmaskErr = "Invalid IP subnet mask.";
    errMsgObjL10N = document.getElementById('hdSnetMaskErr');
    if (errMsgObjL10N) snetmaskErr = errMsgObjL10N.value;
    var gwIpAddrErr = "Invalid Gateway IP address.";
    errMsgObjL10N = document.getElementById('hdGwIpAddrErr');
    if (errMsgObjL10N) gwIpAddrErr = errMsgObjL10N.value;
    var priDnsSvrErr = "Invalid Primary DNS server address.";
    errMsgObjL10N = document.getElementById('hdPriDnsSvrErr');
    if (errMsgObjL10N) priDnsSvrErr = errMsgObjL10N.value;
    var secDnsSvrErr = "Invalid Secondary DNS server addressr.";
    errMsgObjL10N = document.getElementById('hdSecDnsSvrErr');
    if (errMsgObjL10N) secDnsSvrErr = errMsgObjL10N.value;
    /* L10N Error Message Collection End */

    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtWi1LoginUsrName," + loginIdErrMsg;    
    txtFieldIdArr[1] = "txtWanConnRstHour," + resetHoursErrMsg;
    txtFieldIdArr[2] = "txtWanConnRstMin," + resetMinsErrMsg;
    txtFieldIdArr[3] = "txtWanConnRstDelay," + resetDelayErrMsg;
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
         
    var txtFieldIdLoginArr = new Array ();
    txtFieldIdLoginArr[0] = "txtWi1LoginUsrName,"+ loginIdErrMsg;
    
    if (isProblemCharArrayCheck (txtFieldIdLoginArr) == false)
         return false;   

    var idleTimeoutObj = document.getElementById('txtWi1TypeIdleTimeOut');
    if (idleTimeoutObj && !idleTimeoutObj.disabled)
        {
        if (numericValueRangeCheck (idleTimeoutObj, 1, idleTimeoutErrMsg, 5, 999, true, invalidIdleTOErr, minutes) == false)
            return false;
        }

    var hoursObj = document.getElementById('txtWanConnRstHour');
    if (hoursObj && !hoursObj.disabled &&
        numericValueRangeCheck (hoursObj, '', '', 0, 23, true, resetHoursErrMsg1, '') == false)
        return false;

    var minObj = document.getElementById('txtWanConnRstMin');
    if (minObj && !minObj.disabled &&
        numericValueRangeCheck (minObj, '', '', 0, 59, true, resetMinsErrMsg1, '') == false)
        return false;

    var delayObj = document.getElementById('txtWanConnRstDelay');
    if (delayObj && !delayObj.disabled &&
        numericValueRangeCheck (delayObj, '', '', 1, 59, true, resetDelayErrMsg1, resetDelayUnits) == false)
        return false;

    /* validate all IP addresses: check for empty and invalid values */
    if (ipv4AddrOctetsValidate ('tblWi1TypeMyIpAddr', 'IP', false, true, myIpAddreErr, forOctet, true) == false)
        return false;
    if (ipv4AddrOctetsValidate ('tblWi1TypeServIpAddr', 'IP', false, true, svrIpAddreErr, forOctet, true) == false)
        return false;
    if (ipv4AddrOctetsValidate ('tblWi1IpAddr', 'IPD', false, true, staticIpAddrErr, forOctet, true) == false)
        return false;
    if (ipv4AddrOctetsValidate ('tblWi1IpSnetmask', 'SM', false, true, snetmaskErr, forOctet, true) == false)
        return false;
    if (ipv4AddrOctetsValidate ('tblWi1IpGway', 'IPD', false, true, gwIpAddrErr, forOctet, true) == false)
        return false;
    if (ipv4AddrOctetsValidate ('tblWi1DNSPrimary', 'IPD', false, true, priDnsSvrErr, forOctet, true) == false)
        return false;
    if (ipv4AddrOctetsValidate ('tblWi1DNSSec', 'IPD', true, true, secDnsSvrErr, forOctet, true) == false)
        return false;
    
    if(wanIPCheck()==false)
       {
       return false;
       }
    return true;
    }
    
    
/******************************************************************** 
* wan1InitalSettings - validates the page settings
* 
* we are calling this function onload event This function validates page initial settings
* 
* RETURNS: TRUE or FALSE 
*/    
function wan1InitalSettings ()
    {
    wan1IspAustriaEnable ();
    wan1IspOtherEnable ();
    ispLoginYesCheck ();
    ispLoginNoCheck ();
	wanConnRstCkeck ();
    }
        
/******************************************************************** 
* ispLoginYesCheck - enables/disables the feilds
* 
* This function enables/disables the fields by selecting YES radio button
* at ISP Login section
* 
* RETURNS: N/A 
*/ 
    
function ispLoginYesCheck ()
    {
    if (document.getElementById('rdbWi1LoginY').checked)
        {
        fieldStateChangeWr ('', '', '', 'tblWi1LoginSection tblWi1TypeSection tblWi1IpAddrSection tblWi1DNSSection');
        wan1IspAustriaEnable ();
        wan1IspOtherEnable ();
        ipAddrCheck ();
        dnsServerCheck ();
        }
    }


/******************************************************************** 
* ispLoginNoCheck - enables/disables the feilds
* 
* This function enables/disables the fields by selecting NO radio button
* at ISP Login section
* 
* RETURNS: N/A 
*/
    
function ispLoginNoCheck ()
    {
    if (document.getElementById('rdbWi1LoginN').checked)
        {
        fieldStateChangeWr ('', 'tblWi1LoginSection tblWi1TypeSection', '', 'tblWi1IpAddrSection tblWi1DNSSection');
        radioObjWithValueSelect ('Wan.IspType', 2);
        ipAddrCheck ();
        dnsServerCheck ();
        }
    }


/******************************************************************** 
* idleTimeOutCheck - enables/disables the feilds
* 
* This function enables/disables the Minutes text field in ISP Type section by selecting Idle Time out
* keep connected or Idle Timeout radiobuttons
* 
* RETURNS: N/A 
*/
    
function idleTimeOutCheck ()
    {
    depFieldCheck ('rdbWi1TypeKeepConn', true, 'txtWi1TypeIdleTimeOut', '', '', '');
    depFieldCheck ('rdbWi1TypeKeepConn', false, '', '', 'txtWi1TypeIdleTimeOut', '');
    depFieldCheck ('rdbWi1TypeIdleTimeOut', true, '', '', 'txtWi1TypeIdleTimeOut', '');
    depFieldCheck ('rdbWi1TypeIdleTimeOut', false, 'txtWi1TypeIdleTimeOut', '', '', '');
    idleLBCheck();
    }

/******************************************************************** 
* idleLBCheck - checks the load balancing value
* 
* This function checks the load balancing value WAN1 or other WANS
* 
* RETURNS: N/A 
*/

function idleLBCheck ()
    {
    if (document.getElementById('hdWansLBIdleStatus') &&
        document.getElementById('hdWansLBIdleStatus').value == "1")
        {
        // Idle timeout is not allowed in LB mode
        fieldStateSet ('rdbWi1TypeKeepConn','');
        fieldStateChangeWr ('rdbWi1TypeIdleTimeOut', '', '', '');
        fieldStateChangeWr ('txtWi1TypeIdleTimeOut', '', '', '');
        }
    }


/******************************************************************** 
* wan1IspAustriaEnable - 
* 
* 
* 
* RETURNS: N/A 
*/
    
function wan1IspAustriaEnable ()
    {
    if (document.getElementById('rdbWi1TypeAustria').checked)
        {
        fieldStateChangeWr ('txtWi1TypeDmName', '', 'txtWi1TypeAcName rdbWi1TypeKeepConn', 'tblWi1TypeMyIpAddr tblWi1TypeServIpAddr tblWi1IpAddrSection');
         idleTimeOutCheck ();
        ipAddrCheck ();
        }
    }
    
function wan1IspOtherEnable ()
    {
    if (document.getElementById('rdbWi1TypeOther').checked)
        {
        fieldStateChangeWr ('', 'tblWi1TypeMyIpAddr tblWi1TypeServIpAddr', 'txtWi1TypeAcName txtWi1TypeDmName rdbWi1TypeKeepConn', 'tblWi1IpAddrSection');
         idleTimeOutCheck ();
        ipAddrCheck ();
        }
    }
function wanTest (currWanId)
    {
    if (hdPrimWanId.value != null)
        {
        var primWanId = parseInt (hdPrimWanId.value, 10);

        if (currWanId == primWanId)
            {
              window.open('http://www.netgear.com');
            return;
            }
        }
   
    switch (currWanId)
        {
        case 0:  /* WAN1 */
             alert ("The test can be performed after setting WAN Mode to " +
                    "Single Port and selecting Primary Port as WAN1.");
             break;
        case 1:  /* WAN2 */
             alert ("The test can be performed after setting WAN Mode to " +
                    "Single Port and selecting Primary Port as WAN2.");
             break;
        case 7:  /* WAN3 */
             alert ("The test can be performed after setting WAN Mode to " +
                    "Single Port and selecting Primary Port as WAN3.");
             break;
        case 8:  /* WAN4 */
             alert ("The test can be performed after setting WAN Mode to " +
                    "Single Port and selecting Primary Port as WAN4.");
             break;
        default:
             return;
        }
    return;
    }
function wanConnRstCkeck ()
    {
    depFieldCheck ('chkWanConnRstEnable', true, '', '', 'txtWanConnRstHour txtWanConnRstMin txtWanConnRstDelay', '');
    depFieldCheck ('chkWanConnRstEnable', false, 'txtWanConnRstHour txtWanConnRstMin txtWanConnRstDelay', '', '', '');
    }
function ipAddrCheck ()
    {
    var selValue = radioCheckedValueGet ('Wan.IsGetIpDyn');
    if (!selValue) return;
    switch (parseInt(selValue, 10))
        {
        case 0:    /* Use Static IP Address */
            fieldStateChangeWr ('rdbWi1DNSAutomatic chkDhcpClientId txtWansClientIdName chkDhcpVenId','','','tblWi1IpAddr tblWi1IpSnetmask tblWi1IpGway');
            radioObjWithValueSelect ('Wan.GetDnsFromIsp', 0);
            dnsServerCheck ();
            var ispLoginStatus = radioCheckedValueGet('Wan.IspLoginRequired');
            switch (parseInt (ispLoginStatus, 10))
                {
                case 1:        /* YES */
                    fieldStateChangeWr ('','tblWi1IpGway','txtWi1TypeAcName txtWi1TypeDmName','');
                    break;
                default:    /* NO */
                    fieldStateChangeWr ('txtWi1TypeAcName txtWi1TypeDmName','','','tblWi1IpGway');
                    break;
                }
            break;
        case 1:    /* Get Dynamically from ISP */
        default:
            fieldStateChangeWr ('','tblWi1IpAddr tblWi1IpSnetmask tblWi1IpGway','rdbWi1DNSAutomatic txtWi1TypeAcName txtWi1TypeDmName','');
            var ispLoginStatus2 = radioCheckedValueGet('Wan.IspLoginRequired');
            switch (parseInt (ispLoginStatus2, 10))
                {
                case 1:        /* YES */
                    fieldStateChangeWr ('chkDhcpClientId txtWansClientIdName chkDhcpVenId','','','');
                    break;
                default:    /* NO */
                    fieldStateChangeWr ('','','chkDhcpClientId txtWansClientIdName chkDhcpVenId','');
                    ClientIdentifierCheck ();
                    break;
                }
            break;
        }
    }
    
function dnsServerCheck ()
    {
    var selValue = radioCheckedValueGet ('Wan.GetDnsFromIsp');
    if (!selValue) return;
    switch (parseInt(selValue, 10))
        {
        case 0:    /* Use These DNS Servers */
            fieldStateChangeWr ('','','','tblWi1DNSPrimary tblWi1DNSSec');
            break;
        case 1:    /* Get Automatically from ISP */
        default:
            fieldStateChangeWr ('','tblWi1DNSPrimary tblWi1DNSSec','','');
            break;
        }
    }
    
/******************************************************************** 
* wanIPCheck - Validates WAN Ip Address
* 
* This routine validates vlan ip address and checks whether it is in subnet of 
* WAN or any other Vlan
* 
* RETURNS: TRUE or FALSE 
*/

function wanIPCheck()
    {
    var count = parseInt(document.getElementById('hdCount').value,10);
    var resIp = getIPInt('tblWi1IpAddr');
       var wanIP = document.getElementById('tblWi1IpSnetmask');
       var gatewayIP = document.getElementById('tblWi1IpGway');
       var gwIP = getIPInt('tblWi1IpGway');
       var resSnetMask = getIPInt('tblWi1IpSnetmask');
      if(resIp != false && resSnetMask != false)
           {
           for (var i = 1; i < count; i++)
                  {          
            var ifname = document.getElementById('hdIfName'+ i).value;
              var IpAddrId = "hdIpAddr" + i;
             var SnetMaskId = "hdSnet"+ i;
              if(document.getElementById(IpAddrId).value == '0.0.0.0' || document.getElementById(SnetMaskId).value == '0.0.0.0')
                {
                  continue;
                  }
            var Ip = getIPInt1(IpAddrId);
            var IpMask = getIPInt1(SnetMaskId);
            var IpStr = document.getElementById(IpAddrId).value;
            var IpMaskStr = document.getElementById(SnetMaskId).value;
            var SubnetStr = IpStr + " / " + IpMaskStr;
            if (isInSubnetWithBroadCastIp(resIp, Ip, IpMask))
                {
                var errorstr = "WAN IP Address must not be in the subnet of " + ifname +":" + SubnetStr;
                alert (errorstr);
                return false;
                }
            }
        
        /*Begin:Subnet Checking for DMZ interface*/
                  
        var ifname = "DMZ ";
        var IpAddrId = "hdDmzIp";
        var SnetMaskId = "hdDmzSm";
        var dmzIpObj = document.getElementById(IpAddrId);
        var dmzSmObj = document.getElementById(SnetMaskId);
        if(dmzSmObj && dmzSmObj.value != "" && dmzIpObj.value != '0.0.0.0' && dmzIpObj && dmzIpObj.value != "" && dmzIpObj.value != '0.0.0.0')
            {            
            var Ip = getIPInt1(IpAddrId);
            var IpMask = getIPInt1(SnetMaskId);
            var IpStr = document.getElementById(IpAddrId).value;
            var IpMaskStr = document.getElementById(SnetMaskId).value;
            var SubnetStr = IpStr + " / " + IpMaskStr;
            if (isInSubnetWithBroadCastIp(resIp, Ip, IpMask))
                {
                var errorstr = "WAN IP Address must not be in the subnet of " + ifname +":" + SubnetStr;
                alert (errorstr);
                return false;
                }
            
            }
            
        
        /*End:Subnet Checking for DMZ interface*/
        
        /*Begin:Subnet Checking for lo interface*/
        var ipAddr_Lo = getIPInt1('loIpAddr');
        var subnet_Lo = getIPInt1('loSnet');
        if (isInSubnetWithBroadCastIp(resIp , ipAddr_Lo, subnet_Lo))
            {
            var errorstr = "Local interface IP address is in the same subnet. Please specify IP address in a different subnet.";
            alert (errorstr);
            wanIP.focus();
            return false;
            }
        /*End:Subnet Checking for lo interface*/
        var gwIpObj = document.getElementById('IPGateway1');
        if(gwIpObj && !gwIpObj.disabled)
            {
            if (!isInSubnet(gwIP, resIp, resSnetMask))
                {
                alert ("WAN IP address and Gateway should be in the same subnet");
                gatewayIP.focus();
                return false;
                }
            if (gwIP == resIp)
                {
                alert ("WAN IP address and Gateway should not be same.");
                gatewayIP.focus();
                return false;
                }
             }
        
        }
    return true;
    }

function ClientIdentifierCheck ()
    {
    var chkObj = document.getElementById ("chkDhcpClientId");
    if (!chkObj) return;
    if (chkObj.checked)
        fieldStateChangeWr ('','','txtWansClientIdName','');
    else
        fieldStateChangeWr ('txtWansClientIdName','','','');
    }
